<?php
class Brivium_Pokes_Installer extends Brivium_BriviumHelper_Installer
{
	protected $_installerType = 2;

	public static function install($existingAddOn, $addOnData)
	{
		self::$_addOnInstaller = __CLASS__;
		if (self::$_addOnInstaller && class_exists( self::$_addOnInstaller))
		{
			$installer = self::create( self::$_addOnInstaller);
			$installer->installAddOn( $existingAddOn, $addOnData);
		}
		return true;
	}

	public static function uninstall($addOnData)
	{
		self::$_addOnInstaller = __CLASS__;
		if (self::$_addOnInstaller && class_exists( self::$_addOnInstaller))
		{
			$installer = self::create( self::$_addOnInstaller);
			$installer->uninstallAddOn( $addOnData);
		}
	}
	
	public function getTables()
	{
		$tables = array();
		$tables['xf_brivium_poke'] = "
			CREATE TABLE IF NOT EXISTS `xf_brivium_poke` (
			  `poke_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
			  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
			  `poke_user_id` int(10) unsigned NOT NULL DEFAULT '0',
			  `poke_date` int(10) unsigned NOT NULL DEFAULT '0',
			  `response` varchar(25) NOT NULL DEFAULT '',
			  `response_date` int(10) NOT NULL DEFAULT '0',
			  PRIMARY KEY (`poke_id`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8;
		";
		return $tables;
	}
	
	public function getData()
	{
		$data = array();
	
		$data['xf_content_type'] = "REPLACE INTO `xf_content_type` (content_type, addon_id, fields) VALUES ('pokes', 'Brivium_Pokes', '')";
		$data['xf_content_type_field'] = "REPLACE INTO `xf_content_type_field` (content_type, field_name, field_value) VALUES ('pokes', 'alert_handler_class', 'Brivium_Pokes_AlertHandler_Poke')";
	
		return $data;
	}
	
	public function getAlters()
	{
		$alters = array();
		$alters['xf_user_privacy'] = array(
				'allow_poke'	=>	" ENUM(  'everyone',  'members',  'followed',  'none' ) NOT NULL DEFAULT  'everyone'",
		);
		return $alters;
	}
	
	protected function _postInstall()
	{
		if(!empty($this->_existingVersionId) && $this->_existingVersionId < 1010000)
		{
			$db = $this->_getDb();
			$db->query(" TRUNCATE TABLE xf_brivium_poke ");
		}
	}
	
	public function getQueryFinal()
	{
		$query = array();
		$query[] = "
			DELETE FROM `xf_brivium_listener_class` WHERE `addon_id` = 'Brivium_Pokes';
		";
		if($this->_triggerType != "uninstall"){
			$query[] = "
				REPLACE INTO `xf_brivium_addon`
					(`addon_id`, `title`, `version_id`, `copyright_removal`, `start_date`, `end_date`)
				VALUES
					('Brivium_Pokes', 'Brivium - Pokes', '1010100', 0, 0, 0);
			";
			$query[] = "
				REPLACE INTO `xf_brivium_listener_class`
					(`class`, `class_extend`, `event_id`, `addon_id`)
				VALUES
					('XenForo_ControllerPublic_Account', 'Brivium_Pokes_ControllerPublic_Account', 'load_class_controller', 'Brivium_Pokes'),
					('XenForo_ControllerPublic_Member', 'Brivium_Pokes_ControllerPublic_Member', 'load_class_controller', 'Brivium_Pokes'),
					('XenForo_DataWriter_User', 'Brivium_Pokes_DataWriter_User', 'load_class_datawriter', 'Brivium_Pokes');
			";
		}else{
			$query[] = "
				DELETE FROM `xf_brivium_addon` WHERE `addon_id` = 'Brivium_Pokes';
			";
		}
		return $query;
	}
}

?>